/* 
 * CSE142, 99 Winter
 * Homework 5
 * Valentine's Day
 *
 * Author:     Aaron Parks
 * Student ID: 9850395
 * Section:    AD
 *	
 */

#include "gp142.h"
#include <math.h>
#include <time.h>
	/* <time.h> is here only so that one function can be called
	to seed the random number generator.
	Put it here in your program and forget about it, 
	just in case you decide later you need to use random numbers.
	*/

#define TRUE   	1
#define FALSE 	0

/*
 * The state, or status you are in determines what happens when you click 
 * the card:
 * ADD SHAPE        -- You click the card, and a new shape is placed there.
 *                     You get into this mode by clicking an ADD button.
 *
 * ADD MESSAGE      -- Same as ADD SHAPE, but for messages
 *
 * OBJECT SELECTED  -- An object is selected. In this mode, the type 
 *					   rotation applies to the current object.
 *	
 * PLEASE SELECT	-- The user is prompted to select an object.
 *
 * DELETE			-- The three DELETE states refer to the different stages of deletion,
 *					   and are used primarily for animation
 *
 * MOVE				-- A sub-state under OBJECT SELECTED, this one moves the object to 
 *					   whatever new location the user specifies
 *
 * 
 */
/* Hint: you may need to add statuses when you make the program more complex.*/
#define STATUS_ADD_SHAPE		1
#define STATUS_ADD_MESSAGE		2
#define STATUS_OBJECT_SELECTED	3
#define STATUS_PLEASE_SELECT	4
#define STATUS_DELETE_1			5
#define STATUS_DELETE_2			6
#define STATUS_DELETE_3			7
#define STATUS_MOVE				8
#define STATUS_ANIMATED_MOVING  9

/* Buttons */
#define NUMBER_OF_BUTTONS	9
#define BUTTON_ADD_SHAPE	0
#define BUTTON_ADD_MESSAGE	1
#define BUTTON_SELECT		2
#define BUTTON_TYPE			3
#define BUTTON_COLOR		4
#define BUTTON_MOVE			5
#define BUTTON_DELETE		6
#define BUTTON_BGROUND		7
#define BUTTON_RESTART		8

/* Button states */
#define BS_NORMAL 0
#define BS_PUSHED 1
#define BS_SELECTED 2
#define BS_DISABLED 3

/* Button properties */
#define BUTTON_HEIGHT	25
#define BUTTON_WIDTH 	105
#define BUTTON_GAP		7

/* Position of the card in the window */
#define PAGE_LLX	(-GP142_XMAX + BUTTON_WIDTH +60)
#define PAGE_LLY	(-GP142_YMAX + 100)
#define PAGE_WIDTH	(GP142_XMAX - PAGE_LLX - 80)
#define PAGE_HEIGHT	(GP142_YMAX - PAGE_LLY - 50)

/* Other constants */
#define BORDER_WIDTH 50
#define NUMBER_OF_MOVES 20

/* Information about the box which displays the current status */
#define TEXT_OFFSET		70
#define TOP_OF_BOX		PAGE_LLY - 70
#define BOTTOM_OF_BOX	PAGE_LLY - 51

/* For many of the GP142 functions, a line width of
 * zero means to fill the shape being drawn.
 */
#define FILL	0
#define NOFILL	1
#define THICK	2

/* Types of objects */
#define OBJECT_NONE 0
#define OBJECT_SHAPE 1
#define OBJECT_MESSAGE 2

/* The imposed limits on the number of objects on the page */
#define MAX_NUMBER_OF_OBJECTS 20
#define MAX_NUMBER_OF_SHAPES 10
#define MAX_NUMBER_OF_MESSAGES 10

/* Information about the blue ring that surrounds selected objects */
#define MAX_SELECT_DISTANCE 50
#define MAX_SELECT_CIRCLE_SIZE 50

/* Possible places for mouse clicks */
#define CLICK_BUTTON 1  /* You clicked on SOME button (doesn't say which one)*/
#define CLICK_CARD 2    /* You clicked in the card area */
#define CLICK_OUTSIDE 3	/* You clicked outside the card area, not on a button*/	
#define CLICK_CUPID 4	/* You clicked on cupid!!! */

/* 3D colors */
#define COLOR3D_FACE		LT_GRAY
#define COLOR3D_LIGHT		WHITE
#define COLOR3D_SHADOW		MED_GRAY
#define COLOR3D_DARK		BLACK

/* Shape types */
#define MAX_SHAPES 4

#define SHAPE_HEART 0
#define SHAPE_STAR  1
#define SHAPE_SMILEY 2
#define SHAPE_ROSE 3

/* Properties of the smiley face shape */
#define FACE_RADIUS 40
#define EYE_RADIUS 7
#define PUPIL_RADIUS 2
#define NOSE_RADIUS 5

/* Properties of the rose shape */
#define ROSE_WIDTH 30
#define ROSE_HEIGHT 20

/* Properties of the star shape */
#define STARPOINTS 5
#define STARRADIUS 40
#define PI 3.1416

/* Message types */
#define MAX_MESSAGES 5

#define MESSAGE_LOVE 0
#define MESSAGE_BMINE 1
#define MESSAGE_EMAIL 2
#define MESSAGE_VALENTINE 3
#define MESSAGE_ONE 4

/* Information for drawing cupid */
#define CUPID_FACE_WIDTH 100
#define CUPID_FACE_HEIGHT 110
#define CUPID_NOSE_WIDTH 20
#define CUPID_NOSE_HEIGHT 20
#define CUPID_EYE_RADIUS 16
#define CUPID_HAIR_RADIUS CUPID_FACE_WIDTH / 10
#define CUPID_IRIS_RADIUS 4
#define CUPID_MOUTH_WIDTH 10
#define CUPID_PUPIL_RADIUS 1
#define MAX_MOUTH_HEIGHT	30

/* Info about the flying, deleting heart */
#define INITIAL_HEART_X		-GP142_XMAX + 100
#define INITIAL_HEART_Y		-GP142_YMAX / 2 - 30
#define CUPID_HEART_HEIGHT 20
#define CUPID_HEART_WIDTH 20
#define HEART_SPEED			10

/* The boundaries for where it counts as Cupid being clicked on */
#define CUPID_CLICK_X_MIN -GP142_XMAX + 100 - CUPID_FACE_WIDTH / 2
#define CUPID_CLICK_X_MAX -GP142_XMAX + 100 + CUPID_FACE_WIDTH / 4
#define CUPID_CLICK_Y_MIN -GP142_YMAX / 2 + 5 - CUPID_FACE_HEIGHT / 2
#define CUPID_CLICK_Y_MAX -GP142_YMAX / 2 + 5 + CUPID_FACE_HEIGHT / 2

#define NEW_IRIS_COLOR 2 + ((iris_color + 1) % (MAX_COLORS - 2))

/*******************  FUNCTION PROTOTYPES **************************/

/* Drawing functions */
void DrawBlankScreen (void);
void DrawButtons(int button_state[]);
void DrawCard (int background_color, int status, int object_count, 
			   int shape_count, int message_count,
			   int object_type[], int object_ID[], 
			   int object_color[], int object_x[], int object_y[],
			   int s);
void DrawShape(int color, int shape_type, int bottom_x, int bottom_y);
void DrawMessage(int message_type, int color, int x, int y);
void DrawBorder(int select_radius, int status,
				int object_x[], int object_y[],
				int s, int background_color);

void DrawHeart (int x, int y, int color);
void DrawStar (int x, int y, int color);
void DrawSmiley (int x, int y, int color);
void DrawRose (int x, int y, int color);

/* Mouse click handling functions */
void HandleMouseClick(int mouse_x, int mouse_y, int *background_color, 
					  int *status, int *s, int *object_count, 
					  int *shape_count, int *message_count,
					  int button_state[], int object_type[], 
					  int object_ID[], int object_color[], 
					  int object_x[], int object_y[],
					  int *big_enough, int *select_radius,
					  int *final_x, int *final_y, int *stick_tongue);
int ClassifyMouseClick(int mouse_x, int mouse_y);
void HandleButton(int x, int y, int *s, int *object_count,
				  int *shape_count, int *message_count,
				  int *background_color, int button_state[],
				  int *status, int object_color[], int object_type[], int object_ID[],
				  int *big_enough, int *select_radius);
/* Add an object to the card. */
void AddObject(int object_type[], int x, int y, int *status, int *s, 
			   int *object_count, int *shape_count, int *message_count, 
			   int object_ID[], int object_color[], 
			   int object_x[], int object_y[]);

double FindDistance(int x1, int y1,
				    int x2, int y2);

void SelectClosestObject(int mouse_x, int mouse_y,
						 int x[], int y[],
						 int *s, int object_count, int *status,
						 int *big_enough, int *select_radius,
						 int button_state[]);

void Draw3DButton(int x1, int y1,
		          int x2, int y2,
			      char text[],
			      int state);

void DrawCupidFace(int x, int y, int mouth_height, int iris_color, int nose_color);
void DrawCupid(int heart_x, int heart_y,
			     int mouth_height, int status, int iris_color, int nose_color,
				 int background_color);
void DrawCupidHeart(int heart_x, int heart_y, int background_color);
void DrawEye(int x, int y, int iris_color);

/*****************************************************************************

     MAIN

*****************************************************************************/

/* main() has two chief purposes: to contain the important variables and 
 *initialize them, and to contain the "event loop," which constantly looks 
 *to see if an event has happened, and then processes the event by calling 
 *an appropriate function. An example of an event is a mouse click.
 */
int main(void)
{
	int quit = FALSE;              /* becomes TRUE to exit program */
	int mouse_x, mouse_y;          /* coordinates of a mouse click */
	char key_hit;                  /* which key was hit            */

	/*variables and their default values*/
	int background_color = WHITE;
	int status = STATUS_ADD_SHAPE;
	
	/* Each object will have a number telling what kind of object it is, a color,
	 * and an x and y coordinate.  You'll need to make these into arrays so you
	 * can support more than one object.
	 */

	int s = -1;								 /* Index of currently selected
											  * object                        */
	int i;
	
	int first_time = TRUE;
	int final_x, final_y;
	double obj_x, obj_y;
	int count = 0;
	double x_incr, y_incr;

	int shape_count = 0;
	int message_count = 0;	
	int object_count = 0;					 /* How many objects on the page? */

	int object_type[MAX_NUMBER_OF_OBJECTS];  /* Can also be a shape           */
	int object_ID[MAX_NUMBER_OF_OBJECTS];    /* If type is shape, heart, star,
									          * smiley, or rose               */
	int object_color[MAX_NUMBER_OF_OBJECTS]; /* Color of object               */
	int object_x[MAX_NUMBER_OF_OBJECTS];     /* Position of object            */
	int object_y[MAX_NUMBER_OF_OBJECTS];

	int button_state[NUMBER_OF_BUTTONS] = 
	{
		BS_PUSHED, BS_NORMAL, BS_DISABLED, 
		BS_DISABLED, BS_DISABLED, BS_DISABLED, 
		BS_DISABLED, BS_NORMAL, BS_NORMAL
	};
	         
	int big_enough = FALSE;
	int select_radius = 0;
	int mouth_height = 2;

	int change_colors = FALSE;
	
	int iris_color = BLUE;
	int nose_color = ORANGE;

	double distance;

	/* The reason that I need h_x and h_y is because, while the coordinate system 
	 * we use works with ints, I need to keep more accurate values of what the 
	 * EXACT position of the moving heart (so it doesn't get slightly thrown off track
	 */
	double h_x = INITIAL_HEART_X, h_y = INITIAL_HEART_Y;	
	int heart_x = INITIAL_HEART_X, heart_y = INITIAL_HEART_Y;

	int event; /*the most recent GP142 event*/
	time_t t; /*needed only when initializing a random number generator*/
	

	/*
	 * INITIALIZATIONS
	 */
	srand (time(&t));	    /* Seed the random number generator. This is 
							   something you should do if you plan to use 
							   random numbers. Leave it here in your program 
							   and forget about it.*/
	/* These GP142 initializations don't need to be changed */
	GP142_open();           /* Open and init the GP142 Graphics Window      */
	GP142_show_text(0);     /* Hide the text window                         */
	GP142_logging(LOG_OFF); /* Change to LOG_ON if you want it.             */
	
	GP142_clear();	        /* This will clear the window & paint it white. */
	GP142_animate(ANI_RUN); /* Enable periodic events                       */
	
	
	
	/*
	 * The main event loop:
	 * --- ---- ----- -----
	 * wait for the next user action, such as a mouse click or keyboard
	 * keypress, or a periodic update event (allowing us to display the
	 * next frame of an animation -- not used directly in this program)
	 * and call the appropriate function to handle it.  Repeat this until 
	 * the user signals "quit".
	 */
	while (!quit) {  /*this is the famous "event loop" */
		
		/*start by redrawing everything */
		DrawBlankScreen ();
		DrawCard (background_color, status, object_count, 
				  shape_count, message_count,
			      object_type, object_ID, object_color, 
				  object_x, object_y, s);
		DrawBorder (select_radius, status,
					object_x, object_y, s, background_color);
		DrawButtons(button_state);	  /* Show the buttons...*/ 
		DrawCupid(heart_x, heart_y, mouth_height, 
				  status, iris_color, nose_color, background_color);
		distance = sqrt((object_x[s] - heart_x) * (object_x[s] - heart_x) +
					    (object_y[s] - heart_y) * (object_y[s] - heart_y));
		/*Wait for something to happen */
		event = GP142_await_event(&mouse_x, &mouse_y, &key_hit);
		
		/* Something just happened.  Figure out what it was, and react 
		   appropriately. */
		switch (event) {
		case GP142_QUIT:
			quit = TRUE;           /* set flag to terminate loop           */
			break;
			
		case GP142_KBD:  /*A key was pressed */
			break;
			
		case GP142_MOUSE:
			/* A mouse click has occurred. Call the mouse handler to 
			   decide where the click was and react as needed. */
			HandleMouseClick(mouse_x, mouse_y, &background_color, 
							 &status, &s, &object_count, &shape_count, 
							 &message_count, button_state, object_type, 
							 object_ID, object_color, 
							 object_x, object_y,
							 &big_enough, &select_radius,
							 &final_x, &final_y, &change_colors);			
			break;
			
		case GP142_PERIODIC:
			/*An events has occurred simply because some time has passed */


			/* Normally, I would put this all in a function, but
			 * since the code works, and since turning it into a function
			 * would require me to change a lot of non-pointer variables into 
			 * pointers, I will just keep it here */
			if((status == STATUS_OBJECT_SELECTED) && 
			   (big_enough == FALSE))
			{
				select_radius = select_radius + MAX_SELECT_CIRCLE_SIZE / 10;
				button_state[BUTTON_TYPE] = BS_DISABLED;
				button_state[BUTTON_COLOR] = BS_DISABLED;
				button_state[BUTTON_DELETE] = BS_DISABLED;
				button_state[BUTTON_MOVE] = BS_DISABLED;
				if(select_radius >= MAX_SELECT_CIRCLE_SIZE)
				{
					big_enough = TRUE;
					button_state[BUTTON_TYPE] = BS_NORMAL;
					button_state[BUTTON_COLOR] = BS_NORMAL;
					button_state[BUTTON_DELETE] = BS_NORMAL;
					button_state[BUTTON_MOVE] = BS_NORMAL;
				}
			}

			if((status == STATUS_DELETE_1) &&
			   (mouth_height < MAX_MOUTH_HEIGHT))
			{
				mouth_height = mouth_height + 2;

				/* This cycles the eyes through the colors, skipping 
				 * white and black 
				 */
				iris_color = NEW_IRIS_COLOR;
				if(mouth_height >= MAX_MOUTH_HEIGHT)
				{
					mouth_height = MAX_MOUTH_HEIGHT;
					status = STATUS_DELETE_2;
				}
			}
			if((status == STATUS_DELETE_2) &&
			   (distance > MAX_SELECT_DISTANCE) &&
			   (s >= 0))
			{
				iris_color = NEW_IRIS_COLOR;
				h_x = (object_x[s] -
					((distance * (object_x[s] - h_x)) 
							/ (distance + HEART_SPEED)));
				heart_x = (int) h_x;

				h_y = (object_y[s] -
					((distance * (object_y[s] - h_y)) 
							/ (distance + HEART_SPEED)));
				heart_y = (int) h_y;
			}
			else if(status == STATUS_DELETE_2 &&
				    distance <= MAX_SELECT_DISTANCE)
			{
					h_x = INITIAL_HEART_X;
					h_y = INITIAL_HEART_Y;
					heart_x = (int) h_x;
					heart_y = (int) h_y;
					status = STATUS_DELETE_3;
			}
			if(status == STATUS_DELETE_3)
			{
				iris_color = NEW_IRIS_COLOR;
				if(select_radius > 0)
				{
					select_radius = select_radius - 5;
					if(select_radius <= 0)
					{
						select_radius = 0;
					}
				}
				if(mouth_height > 2)
				{
					mouth_height = mouth_height - 2;
					if(mouth_height <= 2)
					{
						mouth_height = 2;
					}
				}
				if(select_radius == 0 && mouth_height == 2)
				{
					if(object_type[s] == OBJECT_SHAPE)
					{
						shape_count = shape_count - 1;
					}
					else if(object_type[s] == OBJECT_MESSAGE)
					{
						message_count = message_count - 1;
					}
					for(i = s; i < object_count; ++i)
					{
						if(i == MAX_NUMBER_OF_OBJECTS)
						{
							object_ID[i] = 0;
							object_color[i] = BLACK;
							object_x[i] = 0;
							object_y[i] = 0;
							object_type[i] = OBJECT_NONE;
						}
						else
						{
							object_ID[i] = object_ID[i + 1];
							object_color[i] = object_color[i + 1];
							object_x[i] = object_x[i + 1];
							object_y[i] = object_y[i + 1];
							object_type[i] = object_type[i + 1];
						}
					}

					object_count = object_count - 1;

					if(object_count == 0)
					{
						button_state[BUTTON_SELECT] = BS_DISABLED;
						button_state[BUTTON_ADD_SHAPE] = BS_PUSHED;
						button_state[BUTTON_ADD_MESSAGE] = BS_NORMAL;
						status = STATUS_ADD_SHAPE;
					}
					else
					{
						button_state[BUTTON_SELECT] = BS_PUSHED;
						if(shape_count != MAX_NUMBER_OF_SHAPES)
						{
							button_state[BUTTON_ADD_SHAPE] = BS_NORMAL;
						}
						if(message_count != MAX_NUMBER_OF_MESSAGES)
						{
							button_state[BUTTON_ADD_MESSAGE] = BS_NORMAL;
						}
						status = STATUS_PLEASE_SELECT;
					}
					button_state[BUTTON_TYPE] =		BS_DISABLED;
					button_state[BUTTON_COLOR] =	BS_DISABLED;
					button_state[BUTTON_DELETE] =	BS_DISABLED;
					button_state[BUTTON_MOVE] =		BS_DISABLED;
					button_state[BUTTON_BGROUND] =	BS_NORMAL;
					button_state[BUTTON_RESTART] =	BS_NORMAL;
					
					select_radius = 0;
					big_enough = FALSE;
					iris_color = BLUE;
				}
			}
			if(status == STATUS_ANIMATED_MOVING)
			{
				if(first_time == TRUE)
				{
					x_incr = (double) (final_x - object_x[s]) / NUMBER_OF_MOVES;
					y_incr = (double) (final_y - object_y[s]) / NUMBER_OF_MOVES;
					obj_x = (double) object_x[s];
					obj_y = (double) object_y[s];
					first_time = FALSE;
				}
				if(count < NUMBER_OF_MOVES)
				{
					obj_x = obj_x + x_incr;
					obj_y = obj_y + y_incr;
					object_x[s] = (int) obj_x;
					object_y[s] = (int) obj_y;
					++count;
				}
				else
				{
					object_x[s] = final_x;
					object_y[s] = final_y;
					count = 0;
					first_time = TRUE;
					status = STATUS_OBJECT_SELECTED;
					button_state[BUTTON_SELECT] = BS_PUSHED;
					if(shape_count != MAX_NUMBER_OF_SHAPES)
					{
						button_state[BUTTON_ADD_SHAPE] = BS_NORMAL;
					}
					if(message_count != MAX_NUMBER_OF_MESSAGES)
					{
						button_state[BUTTON_ADD_MESSAGE] = BS_NORMAL;
					}
					button_state[BUTTON_TYPE] =		BS_NORMAL;
					button_state[BUTTON_COLOR] =	BS_NORMAL;
					button_state[BUTTON_DELETE] =	BS_NORMAL;
					button_state[BUTTON_MOVE] =		BS_NORMAL;
					button_state[BUTTON_BGROUND] =	BS_NORMAL;
					button_state[BUTTON_RESTART] =	BS_NORMAL;

				}

			}
			if(change_colors == TRUE && 
				status != STATUS_DELETE_1 &&
				status != STATUS_DELETE_2 &&
				status != STATUS_DELETE_3)
			{
				iris_color = NEW_IRIS_COLOR;
				nose_color = (nose_color + 1) % MAX_COLORS;
				mouth_height = mouth_height + 10;
				if(mouth_height >= MAX_MOUTH_HEIGHT + 2)
				{
					mouth_height = 2;
				}
				if(iris_color == BLUE)
				{
					change_colors = FALSE;
					mouth_height = 2;
					nose_color = ORANGE;
				}
			}
			break;

		default:
			
			break;
			
		}  /*end switch */

		if(object_count == MAX_NUMBER_OF_OBJECTS &&
			(button_state[BUTTON_ADD_SHAPE] == BS_PUSHED ||
			 button_state[BUTTON_ADD_MESSAGE] == BS_PUSHED))
		{
			button_state[BUTTON_ADD_SHAPE] =	BS_DISABLED;
			button_state[BUTTON_ADD_MESSAGE] =	BS_DISABLED;
			button_state[BUTTON_SELECT] =		BS_PUSHED;
			status = STATUS_PLEASE_SELECT;
		}
		else if(shape_count == MAX_NUMBER_OF_SHAPES &&
				button_state[BUTTON_ADD_SHAPE] == BS_PUSHED)
		{
			button_state[BUTTON_ADD_SHAPE] =	BS_DISABLED;
			button_state[BUTTON_ADD_MESSAGE] =	BS_PUSHED;
			status = STATUS_ADD_MESSAGE;
		}
		else if(message_count == MAX_NUMBER_OF_MESSAGES &&
				button_state[BUTTON_ADD_MESSAGE] == BS_PUSHED)
		{
			button_state[BUTTON_ADD_MESSAGE] =	BS_DISABLED;
			button_state[BUTTON_ADD_SHAPE] =	BS_PUSHED;
			status = STATUS_ADD_SHAPE;
		}
	}  /* end event loop */
	
	
	/*
	 * WRAP-UP
	 */
	GP142_close();         /* clean up and close graphics window   */
	
	return 0;
}  /*end main */

/*****************************************************************************

     FUNCTIONS

*****************************************************************************/
/* 
 * For a blank screen just draw a white rectangle that covers the whole
 * GP142 window.
 */
void DrawBlankScreen (void) {
	int font_size = 14;

	GP142_rectangleXY (COLOR3D_FACE,
					-GP142_XMAX, -GP142_YMAX,
					GP142_XMAX, GP142_YMAX,
					FILL);

} /*end DrawBlankScreen */




/* 
 * Draws the 3D buttons that will be used in the program
 */
void DrawButtons(int button_state[])
{
	char b_labels [NUMBER_OF_BUTTONS][25] = {
		"     Add shape",
		"    Add message",	  
	    "     Select object",
        "    Object types",
		"    Object colors",
		"      Move object",
		"    Delete object",
	    "Background colors",
		"        Restart"
	};
	
	int i, y;
	/* draw each button */
	for(i = 0; i < NUMBER_OF_BUTTONS; i++) 
	{
		y = GP142_YMAX - i * (BUTTON_HEIGHT + BUTTON_GAP) - BUTTON_GAP;

		Draw3DButton(-GP142_XMAX + BUTTON_GAP, y - BUTTON_HEIGHT,
				 -GP142_XMAX + BUTTON_WIDTH, y,
				 b_labels[i], button_state[i]);
	}	
}




/*
 * Render (draw) the page and all its contents.
 */
void DrawCard (int background_color, 
			   int status, 
			   int object_count,
			   int shape_count, 
			   int message_count,
			   int object_type[], 
			   int object_ID[], 
			   int object_color[], 
			   int object_x[], 
			   int object_y[],
			   int s)
{
	int font_size = 11;
	int i;
	int shapes_left = MAX_NUMBER_OF_SHAPES - shape_count;
	int messages_left = MAX_NUMBER_OF_MESSAGES - message_count;
	
	/*
	 * Draw the background of the card.
	 */
	GP142_rectangleXY (background_color,
		PAGE_LLX, PAGE_LLY,
		PAGE_LLX+ PAGE_WIDTH, PAGE_LLY+ PAGE_HEIGHT,
		FILL);
	/* 
	 * Draw a shape on the card, if any currently exist.
	 */
	for(i = 0; i < object_count; i++)
	{
		if(i != s)
		{
			if (object_type[i] == OBJECT_SHAPE)
			{
				DrawShape (object_ID[i], object_color[i], object_x[i], object_y[i]);
			}
			else if(object_type[i] == OBJECT_MESSAGE)
			{
				DrawMessage(object_ID[i], object_color[i], object_x[i], object_y[i]);
			}
		}
	}
	if(s >= 0)
	{
		if (object_type[s] == OBJECT_SHAPE)
		{
			DrawShape (object_ID[s], object_color[s], object_x[s], object_y[s]);
		}
		else if(object_type[s] == OBJECT_MESSAGE)
		{
			DrawMessage(object_ID[s], object_color[s], object_x[s], object_y[s]);
		}
	}



	GP142_rectangleXY(WHITE, 
					  PAGE_LLX, TOP_OF_BOX,
					  PAGE_LLX + PAGE_WIDTH, BOTTOM_OF_BOX,
					  FILL);
	GP142_rectangleXY(BLACK, 
					  PAGE_LLX, TOP_OF_BOX,
					  PAGE_LLX + PAGE_WIDTH, BOTTOM_OF_BOX,
					  NOFILL);

					  
	/*
	 * Write an appropriate status message below the background
	 */
	switch (status) {
	case STATUS_ADD_SHAPE:
		if(shapes_left > 1)
		{
			GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Click on the card to add a shape.  You may add up to %i more shapes.", 
			shapes_left);
		}
		else if(shapes_left == 1)
		{
			GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Click on the card to add a shape.  You may add only one more shape.", 
			shapes_left);
		}
		break;
	case STATUS_ADD_MESSAGE:
		if(messages_left > 1)
		{
			GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Click on the card to add a message.  You may add up to %i more messages.",
			messages_left);
		}
		else if(messages_left == 1)
		{
			GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Click on the card to add a message.  You may add only one more message.",
			messages_left);
		}
		break;
	case STATUS_OBJECT_SELECTED:
		GP142_printfXY (RED, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Object selected.  Change object attributes by clicking appropriate buttons.");
		break;
	case STATUS_PLEASE_SELECT:
		GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Please click on an object to select it.");
		break;
	case STATUS_DELETE_1:
	case STATUS_DELETE_2:
	case STATUS_DELETE_3:
		GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Deleting object...");
		break;
	case STATUS_MOVE:
		GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Click where you want to move this object to.");
		break;
	default:
		GP142_printfXY (BLUE, PAGE_LLX, PAGE_LLY-TEXT_OFFSET, font_size,
			" Status error -- notify programmer");
		break;
	} /*end switch */
	
	
} /*end DrawPage */


/*
 * Draw one shape.
 */
void DrawShape(int shape_type, 
			   int color, 
			   int bottom_x, 
			   int bottom_y) {

	switch (shape_type) {
	case SHAPE_HEART:
		DrawHeart (bottom_x, bottom_y, color);
		break;
	case SHAPE_STAR:
		DrawStar (bottom_x, bottom_y, color);
		break;
	case SHAPE_SMILEY:
		DrawSmiley (bottom_x, bottom_y, color);
		break;
	case SHAPE_ROSE:
		DrawRose (bottom_x, bottom_y, color);
		break;
	default:
		/* Unknown shape selected */
		break;

	} /*end switch*/

}

/* Draw one message */
void DrawMessage(int message_type,
				 int color, 
				 int x, 
				 int y) {

	int font_size = 12;
	switch (message_type) {

	/* Note: The 20, 15, and 30 used below are used to center the object
	 * in the middle of the blue ring when the object is selected */
	case MESSAGE_LOVE:
		GP142_printfXY (color, x - 20, y, font_size, 
			"I love you");	
		break;
	case MESSAGE_BMINE:
		GP142_printfXY (color, x - 15, y, font_size, 
			"Be mine");
		break;
	case MESSAGE_EMAIL:
		GP142_printfXY (color, x - 15, y, font_size, 
			"Email me");
		break;
	case MESSAGE_VALENTINE:
		GP142_printfXY (color, x - 30, y, font_size, 
			"Happy V-Day");
		break;
	case MESSAGE_ONE:
		GP142_printfXY (color, x - 30, y, font_size, 
			"You're the one");
		break;
	default:
		/* Unknown message selected */
		break;

	} /*end switch*/
}

void 
DrawBorder(int select_radius, 
		   int status,
		   int object_x[], 
		   int object_y[],
		   int s, 
		   int background_color)
{
	int ring_color = BLUE;
	int delete_radius = (select_radius + MAX_SELECT_CIRCLE_SIZE) / 2;
	int delete_width = (MAX_SELECT_CIRCLE_SIZE - select_radius);

		if(background_color == BLUE)
	{
		ring_color = YELLOW;
	}
	if(status == STATUS_DELETE_3)
	{
		GP142_ovalXY(background_color,
					 object_x[s] - delete_radius,
					 object_y[s] - delete_radius,
					 object_x[s] + delete_radius,
					 object_y[s] + delete_radius,
					 delete_width);
	}

	GP142_rectangleXY (LT_GRAY,
		PAGE_LLX, 
		PAGE_LLY + PAGE_HEIGHT,
		PAGE_LLX + PAGE_WIDTH + BORDER_WIDTH, 
		PAGE_LLY + PAGE_HEIGHT + BORDER_WIDTH,
		FILL);
	GP142_rectangleXY (LT_GRAY,
		PAGE_LLX - BORDER_WIDTH, 
		PAGE_LLY,
		PAGE_LLX, 
		PAGE_LLY + PAGE_HEIGHT + BORDER_WIDTH,
		FILL);
	GP142_rectangleXY (LT_GRAY,
		PAGE_LLX - BORDER_WIDTH, 
		PAGE_LLY - BORDER_WIDTH,
		PAGE_LLX + PAGE_WIDTH, 
		PAGE_LLY,
		FILL);
	GP142_rectangleXY (LT_GRAY,
		PAGE_LLX + PAGE_WIDTH, 
		PAGE_LLY - BORDER_WIDTH,
		PAGE_LLX + PAGE_WIDTH + BORDER_WIDTH, 
		PAGE_LLY + PAGE_HEIGHT,
		FILL);
	GP142_rectangleXY (BLACK,
		PAGE_LLX, 
		PAGE_LLY,
		PAGE_LLX + PAGE_WIDTH, 
		PAGE_LLY + PAGE_HEIGHT,
		NOFILL);
	if(status == STATUS_OBJECT_SELECTED ||
	   status == STATUS_DELETE_1 ||
	   status == STATUS_DELETE_2 ||
	   status == STATUS_DELETE_3 ||
	   status == STATUS_MOVE     ||
	   status == STATUS_ANIMATED_MOVING)
	{
		GP142_ovalXY(ring_color,
					 object_x[s] - select_radius, 
					 object_y[s] - select_radius,
					 object_x[s] + select_radius,
					 object_y[s] + select_radius,
					 NOFILL);
	}
	/* Draw a reminder about the author of the program */
	GP142_printfXY (BLACK, -GP142_XMAX, -GP142_YMAX, 16,
			" Aaron Parks, Student ID: 9850395");
}


/*
 * Draw a heart on the card. A heart will be made by two overlapping
 * circles and a triangle.
 *
 * The pulsation is caused by adding a small, random amount to the 
 * heart height each time this function is called.
 */
#define HEART_WIDTH 35
void DrawHeart (int x, 
				int y, 
				int color) 
{
	int h = (HEART_WIDTH/2) + (rand () % 4);

	GP142_circleXY (color, x - h + 5, y, h);
	GP142_circleXY (color, x + h - 5, y, h);
	GP142_triangleXY (color, x - h * 2 + 5, y - 5,
						x + h * 2 - 5, y - 5,
						x, y - h * 2 - 5, FILL);

}

/* Draws a smiley face on the card */
void 
DrawSmiley(
		   int x, 
		   int y, 
		   int color
		   ) 
{

	GP142_circleXY(color, x, y, FACE_RADIUS);
	GP142_ovalXY(BLACK, x - FACE_RADIUS, y - FACE_RADIUS,
				 x + FACE_RADIUS, y + FACE_RADIUS,
				 NOFILL);
	GP142_circleXY(WHITE, x - 12, y + 12, EYE_RADIUS);
	GP142_circleXY(BLACK, x - 12, y + 12, PUPIL_RADIUS);
	GP142_circleXY(WHITE, x + 12, y + 12, EYE_RADIUS);
	GP142_circleXY(BLACK, x + 12, y + 12, PUPIL_RADIUS);
	if(color != BLACK)
	{
		GP142_circleXY(BLACK, x, y, NOSE_RADIUS);
		GP142_ovalXY(BLACK, x - 12, y - 25, x + 12, y - 15, FILL);
	}
	else if(color == BLACK)
	{
		GP142_circleXY(PINK, x, y, NOSE_RADIUS);
		GP142_ovalXY(RED, x - 12, y - 25, x + 12, y - 15, FILL);
	}
	GP142_ovalXY(color, x - 12, y - 20, x + 12, y - 10, FILL);
}

/* Draws a rose on the card */
void
DrawRose(
		 int x, 
		 int y, 
		 int color
		 )
{
	int stem_color = FOREST_GREEN;
	GP142_ovalXY(color, 
				 x - ROSE_WIDTH / 2, y - ROSE_HEIGHT / 2, 
				 x + ROSE_WIDTH / 2, y + ROSE_HEIGHT / 2,
				 FILL);
	GP142_triangleXY(color, 
				     x - ROSE_WIDTH / 2, y,
					 x - ROSE_WIDTH / 6, y,
					 x - ROSE_WIDTH / 3, y + ROSE_HEIGHT / 2 + 5,
					 FILL);
	GP142_triangleXY(color, 
				     x - ROSE_WIDTH / 6, y,
					 x + ROSE_WIDTH / 6, y,
					 x, y + ROSE_HEIGHT / 2 + 5,
					 FILL);
	GP142_triangleXY(color, 
				     x + ROSE_WIDTH / 6, y,
					 x + ROSE_WIDTH / 2, y,
					 x + ROSE_WIDTH / 3, y + ROSE_HEIGHT / 2 + 5,
					 FILL);
	if(color == FOREST_GREEN)
		stem_color = BLACK;
	GP142_lineXY(stem_color,
				 x, y - ROSE_HEIGHT / 2,
				 x, y - ROSE_HEIGHT / 2 - 39,
			     THICK);
	GP142_triangleXY(stem_color,
					 x, y - ROSE_HEIGHT / 2 - 30,
				     x, y - ROSE_HEIGHT / 2 - 25,
				     x + 10, y - ROSE_HEIGHT / 2 - 15,
				     FILL);
	GP142_triangleXY(stem_color,
				     x, y - ROSE_HEIGHT / 2 - 20,
				     x, y - ROSE_HEIGHT / 2 - 15,
				     x - 10, y - ROSE_HEIGHT / 2 - 5,
				     FILL);
}
/*
 * Draw a star on the card.
 *
 * We make the star twinkle by selecting the number of points randomly.  Each 
 * time it is redrawn, it is slightly different than the time before, which 
 * makes it appear to pulsate,
 */

void DrawStar (int x, 
			   int y, 
			   int color) {

	int sp;
	double angle;
	int x1, y1;

	sp = STARPOINTS + (rand () %3);
	for (angle = 0.0; angle < 2 * PI; angle = angle + (2*PI)/sp) {
		x1 = (int) (cos (angle) * STARRADIUS);
		y1 = (int) (sin (angle) * STARRADIUS);
		GP142_lineXY (color, x+x1, y+y1, x-x1, y-y1, 1);

	}
}


/*
 * Mouse clicks occur in one of three regions of interest: on buttons, 
 * on the card, or anywhere else.
 */
int ClassifyMouseClick(int mouse_x, 
					   int mouse_y)
{
	int count;
	for(count = 1; count <= NUMBER_OF_BUTTONS; ++count)
	{
		if ((mouse_x < -GP142_XMAX + BUTTON_WIDTH + BUTTON_GAP) &&
		    (mouse_x > -GP142_XMAX + BUTTON_GAP) &&
            (mouse_y < GP142_YMAX - (BUTTON_HEIGHT + BUTTON_GAP) * (count - 1) - BUTTON_GAP) &&
            (mouse_y > GP142_YMAX - (BUTTON_HEIGHT + BUTTON_GAP) * count))
		{
			return CLICK_BUTTON;
		}
	}
  if ((mouse_x >= PAGE_LLX) && 
	  (mouse_x < PAGE_LLX + PAGE_WIDTH) && 
	  (mouse_y >= PAGE_LLY) && 
	  (mouse_y < PAGE_LLY + PAGE_HEIGHT))
    return CLICK_CARD;

  else if(mouse_x >= CUPID_CLICK_X_MIN &&
		  mouse_x < CUPID_CLICK_X_MAX &&
		  mouse_y >= CUPID_CLICK_Y_MIN &&
		  mouse_y < CUPID_CLICK_Y_MAX)
	return CLICK_CUPID;
  else
    return CLICK_OUTSIDE;

}


/*
 * Decide where a mouse click occured, and react appropriately.
 */
void HandleMouseClick(int mouse_x, 
					  int mouse_y, 
					  int *background_color, 
					  int *status, 
					  int *s, 
					  int *object_count, 
					  int *shape_count, 
					  int *message_count,
					  int button_state[], 
					  int object_type[], 
					  int object_ID[], 
					  int object_color[], 
					  int object_x[], 
					  int object_y[],
					  int *big_enough, 
					  int *select_radius,
					  int *final_x,
					  int *final_y,
					  int *change_colors)
{

	int mouse_click;
	mouse_click = ClassifyMouseClick(mouse_x, mouse_y);
			
	if (mouse_click == CLICK_BUTTON) 
	{
		/* A button has been clicked.  Call a function to handle it*/
		/* most of the variables passed as args will NOT change*/
		HandleButton(mouse_x, mouse_y, s, object_count, 
					 shape_count, message_count,
					 background_color, button_state, 
					 status, object_color,
					 object_type, object_ID,
					 big_enough, select_radius);
	} 
	else if (mouse_click == CLICK_CARD) 
	{
		if(*status == STATUS_ADD_SHAPE ||
		   *status == STATUS_ADD_MESSAGE)
		{
			/* Add an object, if there is room */
			AddObject(object_type, mouse_x, mouse_y, status, 
					  s, object_count, shape_count, message_count, 
					  object_ID, object_color, object_x, object_y);
			if(button_state[BUTTON_SELECT] = BS_DISABLED)
			{
				button_state[BUTTON_SELECT] = BS_NORMAL;
			}
		}
		else if(*status == STATUS_MOVE)
		{
			*final_x = mouse_x;
			*final_y = mouse_y;
			*status = STATUS_ANIMATED_MOVING;
			button_state[BUTTON_ADD_SHAPE] =	BS_DISABLED;
			button_state[BUTTON_ADD_MESSAGE] =	BS_DISABLED;
			button_state[BUTTON_SELECT] =		BS_DISABLED;
			button_state[BUTTON_TYPE] =			BS_DISABLED;
			button_state[BUTTON_COLOR] =		BS_DISABLED;
			button_state[BUTTON_MOVE] =			BS_DISABLED;
			button_state[BUTTON_DELETE] =		BS_DISABLED;
			button_state[BUTTON_BGROUND] =		BS_DISABLED;
			button_state[BUTTON_RESTART] =		BS_DISABLED;
		}
		else if(*status == STATUS_PLEASE_SELECT ||
				*status == STATUS_OBJECT_SELECTED)
		{
			SelectClosestObject(mouse_x, mouse_y,
								object_x, object_y,
								s, *object_count, status,
								big_enough, select_radius,
								button_state);
		}

	}
	else if(mouse_click == CLICK_CUPID)
	{
		*change_colors = TRUE;
	}
	/* Ignore any other mouse clicks */
}

/* 
 * Figure out which button was clicked, if any, and do the right 
 * thing.
 */
void HandleButton(int x, 
				  int y, 
				  int *s, 
				  int *object_count, 
				  int *shape_count, 
				  int *message_count,
				  int *background_color,
				  int button_state[],
				  int *status, 
				  int object_color[], 
				  int object_type[], 
				  int object_ID[],
				  int *big_enough,
				  int *select_radius)
{
	int buttonNum = 0;
	
	/* If we're outside of this area, we could not have clicked on
	* a button.
	*/
	if (x > -GP142_XMAX + BUTTON_WIDTH + BUTTON_GAP)  
		return ;	/*That's an error situation*/
	
					/* We know the mouse clicked in the column of buttons. Calculate
					* which one.
	*/
	buttonNum = (GP142_YMAX - y)/(BUTTON_HEIGHT + BUTTON_GAP);	 
	
	switch(buttonNum) {
	case BUTTON_ADD_SHAPE:
		/* Changes the status so that the user can add an object */
		if(button_state[BUTTON_ADD_SHAPE] != BS_DISABLED)
		{
			*status = STATUS_ADD_SHAPE;
			button_state[BUTTON_ADD_SHAPE] = BS_PUSHED;
			if(button_state[BUTTON_ADD_MESSAGE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_MESSAGE] = BS_NORMAL;
			}
			if(button_state[BUTTON_SELECT] != BS_DISABLED)
			{
				button_state[BUTTON_SELECT] = BS_NORMAL;
			}
			button_state[BUTTON_TYPE] =		BS_DISABLED;
			button_state[BUTTON_COLOR] =	BS_DISABLED;
			button_state[BUTTON_MOVE] =		BS_DISABLED;
			button_state[BUTTON_DELETE] =	BS_DISABLED;
			button_state[BUTTON_BGROUND] =	BS_NORMAL;
			button_state[BUTTON_RESTART] =	BS_NORMAL;
		}
		break;
	case BUTTON_ADD_MESSAGE:
		if(button_state[BUTTON_ADD_MESSAGE] != BS_DISABLED)
		{
			*status = STATUS_ADD_MESSAGE;
			if(button_state[BUTTON_ADD_SHAPE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_SHAPE] = BS_NORMAL;
			}
			button_state[BUTTON_ADD_MESSAGE] = BS_PUSHED;
			if(button_state[BUTTON_SELECT] != BS_DISABLED)
			{
				button_state[BUTTON_SELECT] = BS_NORMAL;
			}
			button_state[BUTTON_TYPE] =		BS_DISABLED;
			button_state[BUTTON_COLOR] =	BS_DISABLED;
			button_state[BUTTON_MOVE] =		BS_DISABLED;
			button_state[BUTTON_DELETE] =	BS_DISABLED;
			button_state[BUTTON_BGROUND] =	BS_NORMAL;
			button_state[BUTTON_RESTART] =	BS_NORMAL;
		}
		break;
	case BUTTON_SELECT:
		/* Changes the status so that the user will select an object */
		if(*object_count != 0 && 
			button_state[BUTTON_SELECT] != BS_DISABLED)
		{
			*status = STATUS_PLEASE_SELECT;
			*big_enough = FALSE;
			*select_radius = 0;
			if(button_state[BUTTON_ADD_SHAPE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_SHAPE] = BS_NORMAL;
			}
			if(button_state[BUTTON_ADD_MESSAGE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_MESSAGE] = BS_NORMAL;
			}
			button_state[BUTTON_SELECT] =	BS_PUSHED;
			button_state[BUTTON_TYPE] =		BS_DISABLED;
			button_state[BUTTON_COLOR] =	BS_DISABLED;
			button_state[BUTTON_MOVE] =		BS_DISABLED;
			button_state[BUTTON_DELETE] =	BS_DISABLED;
			button_state[BUTTON_BGROUND] =	BS_NORMAL;
			button_state[BUTTON_RESTART] =	BS_NORMAL;
		}
		break;
	case BUTTON_TYPE:
		/* Change the type of the currently selected object */
		if((*status == STATUS_OBJECT_SELECTED ||
			*status == STATUS_MOVE)&& 
		   button_state[BUTTON_TYPE] != BS_DISABLED)
		{
			if (object_type[*s] == OBJECT_SHAPE)
			{
				object_ID[*s] = (object_ID[*s] + 1) % MAX_SHAPES;
			}
			else if(object_type[*s] == OBJECT_MESSAGE)
			{
				object_ID[*s] = (object_ID[*s] + 1) % MAX_MESSAGES;
			}
			if(button_state[BUTTON_ADD_SHAPE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_SHAPE] =	BS_NORMAL;
			}
			if(button_state[BUTTON_ADD_MESSAGE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_MESSAGE] =	BS_NORMAL;
			}
			button_state[BUTTON_SELECT] =		BS_PUSHED;
			button_state[BUTTON_TYPE] =			BS_SELECTED;
			button_state[BUTTON_COLOR] =		BS_NORMAL;
			button_state[BUTTON_MOVE] =			BS_NORMAL;
			button_state[BUTTON_DELETE] =		BS_NORMAL;
			button_state[BUTTON_BGROUND] =		BS_NORMAL;
		}
		break;
	case BUTTON_COLOR: 
		/* Change the color of the currently selected object */
		if((*status == STATUS_OBJECT_SELECTED ||
			*status == STATUS_MOVE)&& 
			button_state[BUTTON_COLOR] != BS_DISABLED)
		{
			object_color[*s] = (object_color[*s] + 1) % MAX_COLORS;
			if(button_state[BUTTON_ADD_SHAPE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_SHAPE] =	BS_NORMAL;
			}
			if(button_state[BUTTON_ADD_MESSAGE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_MESSAGE] =	BS_NORMAL;
			}
			button_state[BUTTON_SELECT] =		BS_PUSHED;
			button_state[BUTTON_TYPE] =			BS_NORMAL;
			button_state[BUTTON_COLOR] =		BS_SELECTED;
			button_state[BUTTON_MOVE] =			BS_NORMAL;
			button_state[BUTTON_DELETE] =		BS_NORMAL;
			button_state[BUTTON_BGROUND] =		BS_NORMAL;
			button_state[BUTTON_BGROUND] =		BS_NORMAL;
		}
		break;
	case BUTTON_MOVE:
		if(*status == STATUS_OBJECT_SELECTED &&
			button_state[BUTTON_MOVE] != BS_DISABLED)
		{
			*status = STATUS_MOVE;
			if(button_state[BUTTON_ADD_SHAPE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_SHAPE] =	BS_NORMAL;
			}
			if(button_state[BUTTON_ADD_MESSAGE] != BS_DISABLED)
			{
				button_state[BUTTON_ADD_MESSAGE] =	BS_NORMAL;
			}
			button_state[BUTTON_SELECT] =		BS_PUSHED;
			button_state[BUTTON_TYPE] =			BS_NORMAL;
			button_state[BUTTON_COLOR] =		BS_NORMAL;
			button_state[BUTTON_MOVE] =			BS_SELECTED;
			button_state[BUTTON_DELETE] =		BS_NORMAL;
			button_state[BUTTON_BGROUND] =		BS_NORMAL;
			button_state[BUTTON_BGROUND] =		BS_NORMAL;
		}
		break;
	case BUTTON_DELETE:
		if(button_state[BUTTON_DELETE] != BS_DISABLED)
		{
			*status = STATUS_DELETE_1;
			button_state[BUTTON_ADD_SHAPE] =	BS_DISABLED;
			button_state[BUTTON_ADD_MESSAGE] =	BS_DISABLED;
			button_state[BUTTON_SELECT] =		BS_DISABLED;
			button_state[BUTTON_TYPE] =			BS_DISABLED;
			button_state[BUTTON_COLOR] =		BS_DISABLED;
			button_state[BUTTON_MOVE] =			BS_DISABLED;
			button_state[BUTTON_DELETE] =		BS_DISABLED;
			button_state[BUTTON_BGROUND] =		BS_DISABLED;
			button_state[BUTTON_RESTART] =		BS_DISABLED;
		}
		break;
	case BUTTON_BGROUND:
		/* Change the background color */
		if(button_state[BUTTON_BGROUND] != BS_DISABLED)
		{
			*background_color = (*background_color + 1) % MAX_COLORS;
			if(button_state[BUTTON_TYPE] == BS_SELECTED)
			{
				button_state[BUTTON_TYPE] = BS_NORMAL;
			}
			if(button_state[BUTTON_COLOR] == BS_SELECTED)
			{
				button_state[BUTTON_COLOR] = BS_NORMAL;
			}
			if(button_state[BUTTON_MOVE] == BS_SELECTED)
			{
				button_state[BUTTON_MOVE] = BS_NORMAL;
			}
			button_state[BUTTON_RESTART] = BS_NORMAL;
			button_state[BUTTON_BGROUND] = BS_SELECTED;
		}
		break;
	case BUTTON_RESTART:
		/* Clear the screen of all objects */
		if(button_state[BUTTON_RESTART] != BS_DISABLED)
		{
			*object_count = 0;
			*shape_count = 0;
			*message_count = 0;
			*background_color = WHITE;
			*s = -1;
			*status = STATUS_ADD_SHAPE;
			*big_enough = FALSE;
			*select_radius = 0;
			button_state[BUTTON_ADD_SHAPE] =	BS_PUSHED;
			button_state[BUTTON_ADD_MESSAGE] =	BS_NORMAL;
			button_state[BUTTON_SELECT] =		BS_DISABLED;
			button_state[BUTTON_TYPE] =			BS_DISABLED;
			button_state[BUTTON_COLOR] =		BS_DISABLED;
			button_state[BUTTON_MOVE] =			BS_DISABLED;
			button_state[BUTTON_DELETE] =		BS_DISABLED;
			button_state[BUTTON_BGROUND] =		BS_NORMAL;
			button_state[BUTTON_RESTART] =		BS_NORMAL;
		}
		break;
	default:
		*status = 999;
		/*Bad news if this is ever reached! */
		break;
	}
}


/* If there's room for another shape, add it to the card. */
void AddObject(int object_type[], 
			   int x, 
			   int y, 
			   int *status, 
			   int *s, 
			   int *object_count, 
			   int *shape_count, 
			   int *message_count,
			   int object_ID[], 
			   int object_color[], 
			   int object_x[], 
			   int object_y[])
{
	if (*shape_count < MAX_NUMBER_OF_SHAPES && 	
		*status == STATUS_ADD_SHAPE) 
	{
		*object_count = *object_count + 1;
		*shape_count = *shape_count + 1;
		*s = *object_count - 1;
		object_ID[*s] = SHAPE_HEART;
		object_color[*s] = RED;
		object_x[*s] = x;
		object_y[*s] = y;
		object_type[*s] = OBJECT_SHAPE;
	}
	else if (*message_count < MAX_NUMBER_OF_MESSAGES &&
		     *status == STATUS_ADD_MESSAGE)
	{
		*object_count = *object_count + 1;
		*message_count = *message_count + 1;
		*s = *object_count - 1;
		object_ID[*s] = MESSAGE_LOVE;
		object_color[*s] = BLACK;
		object_x[*s] = x;
		object_y[*s] = y;
		object_type[*s] = OBJECT_MESSAGE;
	}
}

/* Finds the distance between two points */
double FindDistance(int x1, 
					int y1,
				    int x2, 
					int y2)
{
	double distance;
	distance = sqrt((x1 - x2) * (x1 - x2) + (y1 - y2) * (y1 - y2));
	return distance;
}

/* Finds and selects the closest object 
 * to a point within a specified range */
void SelectClosestObject(int mouse_x, 
						 int mouse_y,
						 int object_x[], 
						 int object_y[],
						 int *s, 
						 int object_count, 
						 int *status,
						 int *big_enough, 
						 int *select_radius,
						 int button_state[])
{
	int i;

	int i_smallest = 0;			/* Index of smallest distance so far */
	double smallest;	/* Smallest distance so far */
	double distance[MAX_NUMBER_OF_OBJECTS];

	for(i = 0; i < object_count; i++)
	{
		distance[i] = FindDistance(mouse_x, mouse_y, 
								   object_x[i], object_y[i]);
	}
	smallest = distance[0];				/* assume that the first distance is smallest 
										 * and compare it to all the rest */
	for(i = 0; i < object_count; i++)
	{
		if(distance[i] < smallest)
		{
			smallest = distance[i];
			i_smallest = i;
		}
	}
	if(smallest <= MAX_SELECT_DISTANCE)
	{
		*s = i_smallest;
		*status = STATUS_OBJECT_SELECTED;
		*big_enough = FALSE;
		*select_radius = 0;
		if(button_state[BUTTON_BGROUND] != BS_DISABLED)
		{
			button_state[BUTTON_BGROUND] = BS_NORMAL;
		}

	}
}

void
Draw3DButton(
			 int x1, 
			 int y1,
			 int x2, 
			 int y2,
			 char text[],
			 int state
			 )
{
	int text_x = (x1 + 5), text_y = ((y1 + y2) / 2) - 5;
	
	int temp_x, temp_y;

	int font_size = 12;

	if(state == BS_PUSHED)
	{
		temp_x = x1;
		x1 = x2;
		x2 = temp_x;
		temp_y = y1;
		y1 = y2;
		y2 = temp_y;
	}
	else if(state == BS_SELECTED)
	{
		GP142_rectangleXY(COLOR3D_DARK, x1, y1, x2, y2, 1);
		++x1;
		++y1;
		--x2;
		--y2;
	}
	GP142_rectangleXY(COLOR3D_FACE, x1, y1, x2, y2, 0);
	GP142_lineXY(COLOR3D_DARK, x1, y1, x2, y1, 1);
	GP142_lineXY(COLOR3D_DARK, x2, y1, x2, y2, 1);

	--x2;
	++y1;

	GP142_lineXY(COLOR3D_LIGHT, x1, y1, x1, y2, 1);
	GP142_lineXY(COLOR3D_LIGHT, x1, y2, x2, y2, 1);

	++x1;
	--y2;

	GP142_lineXY(COLOR3D_SHADOW, x1, y1, x2, y1, 1);
	GP142_lineXY(COLOR3D_SHADOW, x2, y1, x2, y2, 1);
	
	if(state == BS_DISABLED)
	{
		GP142_printfXY(WHITE, text_x + 1, text_y - 1,
					   font_size, text);
		GP142_printfXY(MED_GRAY, text_x, text_y, font_size, text);
	}
	else
	{
		if(state == BS_PUSHED)
		{
			GP142_printfXY(BLACK, text_x + 1, text_y - 1, 
						   font_size, text);
		}
		else
		{
			GP142_printfXY(BLACK, text_x, text_y, font_size, text);
		}
	}
}

void
DrawCupid(int heart_x, 
		  int heart_y, 
		  int mouth_height, 
		  int status, 
		  int iris_color,
		  int nose_color,
		  int background_color)
{
	int facecenter_x = -GP142_XMAX + 100;
	int facecenter_y = -GP142_YMAX / 2 + 5;

	DrawCupidFace(facecenter_x, facecenter_y, mouth_height, iris_color, nose_color);
	if(status == STATUS_DELETE_2)
	{
		DrawCupidHeart(heart_x, heart_y, background_color);
	}
}

void
DrawCupidHeart(int heart_x, 
			   int heart_y,
			   int background_color)
{
	int heart_color = RED;
	if(background_color == RED)
	{
		heart_color = PINK;
	}

	GP142_triangleXY(heart_color,
					 heart_x - CUPID_HEART_WIDTH / 2, heart_y + CUPID_HEART_HEIGHT,
					 heart_x + CUPID_HEART_WIDTH / 2, heart_y + CUPID_HEART_HEIGHT,
					 heart_x, heart_y,
					 FILL);
	GP142_circleXY(heart_color,
				   heart_x - CUPID_HEART_WIDTH / 4, heart_y + CUPID_HEART_HEIGHT,
				   CUPID_HEART_WIDTH / 4);
	GP142_circleXY(heart_color,
				   heart_x + CUPID_HEART_WIDTH / 4, heart_y + CUPID_HEART_HEIGHT,
				   CUPID_HEART_WIDTH / 4);
}

void
DrawCupidFace(int x, 
			  int y, 
			  int mouth_height, 
			  int iris_color, 
			  int nose_color)
{

	GP142_ovalXY(PEACH,
				 x - CUPID_FACE_WIDTH / 2,
				 y - CUPID_FACE_HEIGHT / 2,
				 x + CUPID_FACE_WIDTH / 4,
				 y + CUPID_FACE_HEIGHT / 2,
				 FILL);
	GP142_ovalXY(BLACK,
				 x - CUPID_FACE_WIDTH / 2,
				 y - CUPID_FACE_HEIGHT / 2,
				 x + CUPID_FACE_WIDTH / 4,
				 y + CUPID_FACE_HEIGHT / 2,
				 NOFILL);


	DrawEye(x + CUPID_EYE_RADIUS / 2, 
		    y + CUPID_NOSE_HEIGHT / 2 + CUPID_EYE_RADIUS, iris_color);
	DrawEye(x - CUPID_EYE_RADIUS, 
		    y + CUPID_NOSE_HEIGHT / 2 + CUPID_EYE_RADIUS, iris_color);
	GP142_ovalXY(nose_color,
				 x - CUPID_NOSE_WIDTH / 2,
				 y - CUPID_NOSE_HEIGHT / 4,
				 x + CUPID_NOSE_WIDTH / 2,
				 y + 3 * CUPID_NOSE_HEIGHT / 4,
				 FILL);
	GP142_ovalXY(BLACK,
				 x - CUPID_NOSE_WIDTH / 2,
				 y - CUPID_NOSE_HEIGHT / 4,
				 x + CUPID_NOSE_WIDTH / 2,
				 y + 3 * CUPID_NOSE_HEIGHT / 4,
				 NOFILL);

	GP142_ovalXY(BLACK,
				 x - CUPID_MOUTH_WIDTH / 2,
				 y - CUPID_FACE_HEIGHT / 4 - mouth_height / 2,
				 x + CUPID_MOUTH_WIDTH / 2, 
				 y - CUPID_FACE_HEIGHT / 4 + mouth_height / 2,
				 FILL);
}

void DrawEye(int x, 
			 int y, 
			 int iris_color)
{
	GP142_circleXY(WHITE,
				   x, y, 
				   CUPID_EYE_RADIUS);
	GP142_circleXY(iris_color,
				   x, y, 
				   CUPID_IRIS_RADIUS);
	GP142_circleXY(BLACK, x, y, CUPID_PUPIL_RADIUS);
	GP142_ovalXY(BLACK,
				 x - CUPID_EYE_RADIUS,
				 y - CUPID_EYE_RADIUS,
				 x + CUPID_EYE_RADIUS,
				 y + CUPID_EYE_RADIUS,
				 NOFILL);
}
